require "prefabutil"

local assets=
{
	Asset("ANIM", "anim/flowerpot.zip"),
}
local prefabs=
{
    "collapse_small",
}
local names = {"f1","f2","f3","f4","f5","f6","f7","f8","f9","f10"}

local function onsave(inst, data)
	data.anim = inst.animname
end

local function onload(inst, data)
    if data and data.anim then
        inst.animname = data.anim
	    inst.AnimState:PlayAnimation(inst.animname)
	end
end


local function onhammered(inst, worker)
    SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
    inst.components.lootdropper:DropLoot()
    inst.SoundEmitter:PlaySound("dontstarve/common/destroy_pot")
    inst:Remove()
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddSoundEmitter()
	inst.entity:AddAnimState()
    inst.AnimState:SetBank("ferns_potted")

    inst.animname = names[math.random(#names)]
    inst.AnimState:SetBuild("flowerpot")
    inst.AnimState:PlayAnimation(inst.animname)
    inst.AnimState:SetRayTestOnBB(true); 
	
    inst:AddTag("flower") --添加：标签【花】  --为了产生蝴蝶
	
    inst:AddComponent("inspectable")
	
  
    inst:AddComponent("sanityaura")   --添加：组件【理智光环】
    inst.components.sanityaura.aura = TUNING.SANITYAURA_SMALL*0.1  --25 * 0.1 = 2.5/min
	
	inst:ListenForEvent( "dusktime", function()
           for k = 1,math.random(1,5) do
               local pt1 = inst:GetPosition()
               local fireflies = SpawnPrefab("fireflies")
               fireflies.Transform:SetPosition(pt1.x+(math.random(5)-math.random(5)), 0, pt1.z+(math.random(5)-math.random(5)))  --一格范围内随机产生
           end
    end , GetWorld() )
    inst:ListenForEvent( "daytime", function()
        local pos = Vector3(inst.Transform:GetWorldPosition())
        local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 5)
        for k,v in pairs(ents) do
            if v.prefab == "fireflies" and not v.components.inventoryitem:IsHeld() then
               v:Remove()
            end
        end
    end , GetWorld() )
   
	MakeSmallBurnable(inst)
    MakeSmallPropagator(inst)

    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(1)
    inst.components.workable:SetOnFinishCallback(onhammered)

    inst:AddComponent("lootdropper")

    --------SaveLoad
    inst.OnSave = onsave 
    inst.OnLoad = onload 
    
    return inst
end

return Prefab( "common/objects/flowerpot", fn, assets),
    MakePlacer( "common/flowerpot_placer", "flowerpot", "flowerpot", "f1")
